import loading, gui, pygame, os, mappainter, level_loader, random   
import sonar, units, game_timer
from pygame import *

try:
    import psyco
    psyco.background()
    print "psyco installed"
except:
    print "psyco not installed"
    pass

class game_states:
    def __init__(self):
        pygame.init()
        self.background_screen = pygame.display.set_mode((640,480))
        pygame.display.set_caption("Search for the Red Herring - 0.1")
        self.clock = pygame.time.Clock()
        self.background_screen.fill([0,0,0])
        self.on_state = 'Play'
        self.level = 1
        self.base_fish = 0

    def menu(self):
        pass

    def play(self):
        #game time!
        level_data = level_loader.load_data(1)#(self.level)
        
        globex, globey = level_data[1][0][0]*-50+300, level_data[1][0][1]*-50+200
        
        letters = "smd!@#$%^&*12345678"
        images = ( loading.load_image('shallow_water.png')[0],
                       loading.load_image('moderate_water.png')[0],
                       loading.load_image('deep_water.png')[0],
                       
                       loading.load_image('moderate-to-shallow-BL-TR.png')[0],
                       loading.load_image('moderate-to-shallow-BR-TL.png')[0],
                       loading.load_image('moderate-to-shallow-B-T.png')[0],
                       loading.load_image('moderate-to-shallow-L-R.png')[0],
                       loading.load_image('moderate-to-shallow-R-L.png')[0],
                       loading.load_image('moderate-to-shallow-T-B.png')[0],
                       loading.load_image('moderate-to-shallow-TL-BR.png')[0],
                       loading.load_image('moderate-to-shallow-TR-BL.png')[0],

                       loading.load_image('deep-to-moderate-BL-TR.png')[0],
                       loading.load_image('deep-to-moderate-BR-TL.png')[0],
                       loading.load_image('deep-to-moderate-B-T.png')[0],
                       loading.load_image('deep-to-moderate-L-R.png')[0],
                       loading.load_image('deep-to-moderate-R-L.png')[0],
                       loading.load_image('deep-to-moderate-T-B.png')[0],
                       loading.load_image('deep-to-moderate-TL-BR.png')[0],
                       loading.load_image('deep-to-moderate-TR-BL.png')[0] )
        
        filename = "map1.plm"
        our_map = mappainter.Flat_Tile_Map(globex, globey, level_data[0][0][0], level_data[0][0][1], 50)
        our_map.load(filename)
        our_map.load_tiles(letters,images)
        

        clock = pygame.time.Clock()
        

        p_sonar = sonar.Sonar()
        timer = game_timer.Player_Timer(level_data[4])

        player_base = units.PlayerBase(level_data[6][0], self.base_fish)
        p_sonar.add_player(player_base)
        
        player = units.Player(level_data[1][0])
        p_sonar.add_player(player)
        player_attackers = []
        player_harvesters = []
        player_attack_counter = 0
        player_spawning_attack = False
        player_energy = 200
        player_energy_drain = 0
        
        enemy = units.RedHerring(level_data[3][0])
        p_sonar.add_enemy(enemy)
        enemy_attackers = []
        enemy_attack_counter = random.randint(0,30)


        decoys = []
        decoy_attackers = []
        decoy_attack_counter = random.randint(0,30)
        for decoy in level_data[7]:
            decoys.append(units.Decoy(decoy))
        for decoy in decoys:
            p_sonar.add_enemy(decoy)
        neut_group = []
        for neut_pos in level_data[2]:
            neut_group.append(units.Herring(neut_pos))
        for neut in neut_group:
            p_sonar.add_neut(neut)

        rocks = []
        for rock in level_data[5]:
            rocks.append(units.Rock(rock))

        exit_button = gui.Button(100, 25, 'button.png', True)
        moving_y = 0
        moving_x = 0

        player_attack_target = enemy


        while 1:
            clock.tick(30)
            #print clock.get_fps()
            
            self.background_screen.fill([0,0,0])
            m_d = gui.mouse_down(1)
            if exit_button.clicked(m_d) == True:
                self.on_state = "Exit-Now"
                break

            for event in pygame.event.get():
                if event.type == KEYDOWN:
                    if event.key == K_DOWN:
                        moving_y = 1
                    if event.key == K_UP:
                        moving_y = -1
                    if event.key == K_RIGHT:
                        moving_x = 1
                    if event.key == K_LEFT:
                        moving_x = -1
                    if event.key == K_a:
                        player_spawning_attack = True
                    if event.key == K_s:
                        if player.crew >= 2:
                            if len(player_harvesters) <= 5:
                                player_harvesters.append(units.PenguinHarvester(player.rect.topleft, neut_group))
                                player.crew -= 1

                    if event.key == K_q:
                        if player.rect.colliderect(player_base.rect):
                            if player_base.num_fish > 0:
                                player_energy += 50
                                player_base.num_fish -= 1
                                self.base_fish -= 1

                    if event.key == K_w:
                        if player_energy > 150:
                            if player.rect.colliderect(player_base.rect):
                                if player_base.num_fish < 8:
                                    player_energy -= 50
                                    player_base.num_fish += 1
                                    self.base_fish += 1

                    if event.key == K_e:
                        if player_base.num_crew >= 1:
                            if player.rect.colliderect(player_base.rect):
                                if player.crew < 20:
                                    player.crew += 1
                                    player_base.num_crew -= 1

                elif event.type == KEYUP:
                    if event.key == K_DOWN:
                        moving_y = 0
                    if event.key == K_UP:
                        moving_y = 0
                    if event.key == K_RIGHT:
                        moving_x = 0
                    if event.key == K_LEFT:
                        moving_x = 0
                    if event.key == K_a:
                        player_spawning_attack = False

            if player_spawning_attack:
                player_attack_counter += 1
                if player_attack_counter == 10:
                    player_attack_counter = 0
                    if len(player_attackers) < 5:
                        if player_energy >= 1:
                            if player.crew >= 2:
                                player_energy -= 10
                                player.crew -= 1
                                player_attackers.append(units.PenguinAttack(player.rect, player_attack_target))


            for rock in rocks:
                if player.small_rect.colliderect(rock.small_rect):
                    if player.rect.centerx <= rock.rect.centerx:
                        player.rect.centerx -= 3
                        globex += 3
                    else:
                        player.rect.centerx += 3
                        globex -= 3

                    if player.rect.centery <= rock.rect.centery:
                        player.rect.centery -= 3
                        globey += 3
                    else:
                        player.rect.centery += 3
                        globey -= 3

            if player.small_rect.colliderect(player_base.rect):
                if player.rect.centerx <= player_base.rect.centerx:
                    player.rect.centerx -= 3
                    globex += 3
                else:
                    player.rect.centerx += 3
                    globex -= 3

                if player.rect.centery <= player_base.rect.centery:
                    player.rect.centery -= 3
                    globey += 3
                else:
                    player.rect.centery += 3
                    globey -= 3


            if player_energy > 0:
                if moving_x == 1:
                    globex -= moving_x*3
                    player.rect.left += moving_x*3
                    if moving_x != 0 or moving_y != 0:
                        player_energy_drain += 1
                        if player_energy_drain >= 15:
                            player_energy -= 1
                            player_energy_drain = 0
                if moving_x == -1:
                    globex -= moving_x*3
                    player.rect.left += moving_x*3
                    if moving_x != 0 or moving_y != 0:
                        player_energy_drain += 1
                        if player_energy_drain >= 15:
                            player_energy -= 1
                            player_energy_drain = 0
                if moving_y == 1:
                    globey -= moving_y*3
                    player.rect.top += moving_y*3
                    if moving_x != 0 or moving_y != 0:
                        player_energy_drain += 1
                        if player_energy_drain >= 15:
                            player_energy -= 1
                            player_energy_drain = 0
                if moving_y == -1:
                    globey -= moving_y*3
                    player.rect.top += moving_y*3
                    if moving_x != 0 or moving_y != 0:
                        player_energy_drain += 1
                        if player_energy_drain >= 15:
                            player_energy -= 1
                            player_energy_drain = 0
            else:
                if timer.cur_time < timer.duration - 5:
                    timer.cur_time = timer.duration - 5

            if player.rect.left <= 0:
                player.rect.left += 1
                globex -= 1
            if player.rect.right >= 40*50:
                player.rect.right -= 1
                globex += 1
            if player.rect.top <= 0:
                player.rect.top += 1
                globey -= 1
            if player.rect.bottom >= 40*50:
                player.rect.bottom -= 1
                globey += 1

            for p_har in player_harvesters:
                try:
                    if not p_har.have_fish:
                        if not p_har.rect.colliderect(p_har.closest_neut.rect):
                            p_har.move()
                        else:
                            p_har.damage_counter += 1
                            p_har.on_animation = "harvesting"
                            if p_har.damage_counter == 15:
                                p_har.have_fish = True
                    else:
                        if not p_har.rect.colliderect(player.rect):
                            p_har.move()
                        else:
                            player_energy += 50
                            player.crew += 1
                            player_harvesters.remove(p_har)
                except:
                    pass
                    
                
            for p_attack in player_attackers:
                p_attack.should_move = True
                p_attack.update(player_attack_target)
                if p_attack.duration >= 225:
                    player_attackers.remove(p_attack)
                if not p_attack.rect.colliderect(enemy.rect):
                    pass
                else:
                    p_attack.should_move = False
                    p_attack.on_animation = "attacking"
                    p_attack.damage_counter += 1
                    if p_attack.damage_counter == 25:
                        enemy.hull_health -= random.randint(2,3)
                        p_attack.damage_counter = 0

            for p_attack in player_attackers:
                for decoy in decoys:
                    if not p_attack.rect.colliderect(decoy.rect):
                        pass
                    else:
                        p_attack.should_move = False
                        p_attack.on_animation = "attacking"
                        p_attack.damage_counter += 1
                        if p_attack.damage_counter == 25:
                            decoy.hull_health -= random.randint(2,3)
                            p_attack.damage_counter = 0

            for p_attack in player_attackers:
                if p_attack.should_move == True:
                    p_attack.move(rocks)

            for e_attack in enemy_attackers:
                e_attack.update(player)
                if e_attack.duration >= 175:
                    enemy_attackers.remove(e_attack)
                if not e_attack.rect.colliderect(player.rect):
                    e_attack.move(rocks)
                else:
                    e_attack.on_animation = "attacking"
                    e_attack.damage_counter += 1
                    if e_attack.damage_counter == 25:
                        player.hull_health -= random.randint(1,2)
                        e_attack.damage_counter = 0

            for e_attack in decoy_attackers:
                e_attack.update(player)
                if e_attack.duration >= 175:
                    decoy_attackers.remove(e_attack)
                if not e_attack.rect.colliderect(player.rect):
                    e_attack.move(rocks)
                else:
                    e_attack.on_animation = "attacking"
                    e_attack.damage_counter += 1
                    if e_attack.damage_counter == 25:
                        player.hull_health -= random.randint(1,2)
                        e_attack.damage_counter = 0


            for decoy in decoys:
                if player.really_big_rect.colliderect(decoy.rect):
                    decoy_attack_counter += 1
                    if decoy_attack_counter >= 35:
                        decoy_attack_counter = 0
                        if len(decoy_attackers) <= 4:
                            decoy_attackers.append(units.PiranhaAttack(decoy.rect, player))
                            
            if player.really_big_rect.colliderect(enemy.rect):
                enemy_attack_counter += 1
                if enemy_attack_counter >= 35:
                    enemy_attack_counter = 0
                    if len(enemy_attackers) <= 4:
                        enemy_attackers.append(units.PiranhaAttack(enemy.rect, player))
                        


            if player.big_rect.colliderect(enemy.rect):
                player_attack_target = enemy
            else:
                for decoy in decoys:
                    if player.big_rect.colliderect(decoy.rect):
                        player_attack_target = decoy
            
                

            if enemy.hull_health <= 0:
                self.on_state = "Next-Level"
                self.level += 1
                break
            for decoy in decoys:
                if decoy.hull_health <= 0:
                    decoys.remove(decoy)
            if timer.cur_time == timer.duration:
                self.on_state = "End"
                break
            if player.hull_health <= 0:
                self.on_state = "End"
                break

                
            if moving_y == 1:
                if moving_x == 1:
                    player.facing = 5#correct
                if moving_x == 0:
                    player.facing = 3#correct
                if moving_x == -1:
                    player.facing = 1#correct
            if moving_y == 0:
                if moving_x == 1:
                    player.facing = 7#correct
                if moving_x == 0:
                    pass             #correct
                if moving_x == -1:
                    player.facing = 15#correct
            if moving_y == -1:
                if moving_x == 1:
                    player.facing = 9
                if moving_x == 0:
                    player.facing = 11
                if moving_x == -1:
                    player.facing = 13

            if moving_x == 0:
                if moving_y == 0:
                    player.on_animation = "still"
                else:
                    player.on_animation = "moving"
            else:
                player.on_animation = "moving"


            for inc in p_sonar.incoming:
                p_sonar.remove_incoming(inc)
            for inc in enemy_attackers:
                p_sonar.add_incoming(inc)
            for inc in decoy_attackers:
                p_sonar.add_incoming(inc)

            p_sonar.sweep_from( ( int(player.rect.left/50) ,int(player.rect.top/50) ) )
            p_sonar.sweep_map()
            our_map.draw(self.background_screen)
            our_map.globex, our_map.globey = globex, globey
            for p_har in player_harvesters:
                p_har.draw(self.background_screen, globex, globey)
                p_har.update(player)
                if p_har.duration >= 250:
                    player_harvesters.remove(p_har)
            for rock in rocks:
                rock.draw(self.background_screen, globex, globey)
            for p_attack in player_attackers:
                p_attack.draw(self.background_screen, globex, globey)
            for e_attack in enemy_attackers:
                e_attack.draw(self.background_screen, globex, globey)
            player.draw(self.background_screen, globex, globey)
            player_base.draw(self.background_screen, globex, globey)
            player.update()
            enemy.draw(self.background_screen, globex, globey)
            enemy.update(rocks)
            for decoy in decoys:
                decoy.draw(self.background_screen, globex, globey)
                decoy.update(rocks)
            for d_attack in decoy_attackers:
                d_attack.draw(self.background_screen, globex, globey)
            for neut in neut_group:
                neut.draw(self.background_screen, globex, globey)
            exit_button.draw(self.background_screen, 'exit')

            timer.update(self.level, player_energy, player.hull_health, player.crew)
            p_sonar.draw(self.background_screen)
            timer.draw(self.background_screen)
            pygame.display.flip()

    def levelup(self):
        hello = gui.MessageBox(200, 75, 200, 50, 2)
        hello.add_message("You passed the level!")
        lev = gui.MessageBox(200, 125, 200, 50, 2)
        lev.add_message("level: "+str(self.level)) 
        self.background_screen.fill([0,0,0])
        exit_button = gui.Button(475, 400, 'button.png', True)

        while 1:
            self.background_screen.fill([0,0,0])
            exit_button.draw(self.background_screen, 'Continue')
            hello.draw(self.background_screen)
            lev.draw(self.background_screen)
            pygame.display.flip()
            m_d = gui.mouse_down(1)
            if exit_button.clicked(m_d) == True:
                self.on_state = "Play"
                break

    def end(self):
        hello = gui.MessageBox(200, 75, 200, 50, 2)
        hello.add_message("Game Over, You lost!")
        lev = gui.MessageBox(200, 125, 200, 50, 2)
        lev.add_message("level: "+str(self.level)) 
        self.background_screen.fill([0,0,0])
        exit_button = gui.Button(475, 400, 'button.png', True)

        while 1:
            self.background_screen.fill([0,0,0])
            exit_button.draw(self.background_screen, 'EXIT')
            hello.draw(self.background_screen)
            lev.draw(self.background_screen)
            pygame.display.flip()
            m_d = gui.mouse_down(1)
            if exit_button.clicked(m_d) == True:
                print "you quit"
                self.on_state = "Exit-Now"
                break


game = game_states()
while 1:
    if game.on_state == 'Play':
        game.play()

    if game.on_state == 'Next-Level':
        game.levelup()

    if game.on_state == 'End':
        game.end()

    if game.on_state == "Exit-Now":
        pygame.quit()
        break
#profile.run('game.play()')
